diff -r 6a97faf3e500 src/login-common/ssl-proxy-openssl.c
--- a/src/login-common/ssl-proxy-openssl.c	Tue Nov 27 23:06:38 2012 +0200
+++ b/src/login-common/ssl-proxy-openssl.c	Thu Nov 29 08:16:50 2012 +0200
@@ -407,6 +407,18 @@
 
 	switch (err) {
 	case SSL_ERROR_WANT_READ:
+#ifdef __APPLE__
+		if (!proxy->client_proxy &&
+		    net_geterror(proxy->fd_ssl) == ENOTCONN) {
+			/* OSX bug? OpenSSL goes to infinite loop by assuming
+			   ENOTCONN isn't a fatal error. apparently OSX does
+			   this if socket is disconnected before ACK is
+			   received. */
+			errstr = t_strdup_printf("%s syscall failed: %s",
+						 func_name, strerror(ENOTCONN));
+			break;
+		}
+#endif
 		ssl_set_io(proxy, SSL_ADD_INPUT);
 		break;
 	case SSL_ERROR_WANT_WRITE:
